ROOT_CRT_KEYWORD="Subject: C = US, O = Let's Encrypt, CN = R"
ROOT_CRT_KEYWORD2="Subject: C=US, O=Let's Encrypt, CN=R"

NOW=$(date +"%Y%m%d")

DIRECTORY_SCRIPT="${DIRECTORY_ROOT}/script"
DIRECTORY_SITE="${DIRECTORY_ROOT}/${SITENAME}"
DIRECTORY_CERTIFICATES=${DIRECTORY_SITE}/${NOW}

SYMBOLICLINK_KEY=${DIRECTORY_SITE}/${SITENAME}.key.pem
SYMBOLICLINK_CRT_COMBINED=${DIRECTORY_SITE}/${SITENAME}.combined.crt
SYMBOLICLINK_CRT=${DIRECTORY_SITE}/${SITENAME}.crt
SYMBOLICLINK_CRT_ROOTBUNDLE=${DIRECTORY_SITE}/${SITENAME}.rootbundle.crt

mkdir -p ${DIRECTORY_CERTIFICATES}

ACCOUNT_PRIVATE_KEY=$( cat ${FILEPATH_ACCOUNT_PRIVATE_KEY} )
ACCOUNT_PUBLIC_KEY=$( openssl rsa -in ${FILEPATH_ACCOUNT_PRIVATE_KEY} -outform PEM -pubout )

PATH_PRIVATE_KEY=${DIRECTORY_CERTIFICATES}
FILENAME_PRIVATE_KEY=${SITENAME}_${NOW}.key.pem
FILEPATH_PRIVATE_KEY=${PATH_PRIVATE_KEY}/${FILENAME_PRIVATE_KEY}

PATH_CSR=${DIRECTORY_CERTIFICATES}
FILENAME_CSR=${SITENAME}_${NOW}.csr
FILEPATH_CSR=${PATH_CSR}/${FILENAME_CSR}

PATH_CRT_COMBINED=${DIRECTORY_CERTIFICATES}
FILENAME_CRT_COMBINED=${SITENAME}_${NOW}.combined.crt
FILEPATH_CRT_COMBINED=${PATH_CRT_COMBINED}/${FILENAME_CRT_COMBINED}

PATH_CRT=${DIRECTORY_CERTIFICATES}
FILENAME_CRT=${SITENAME}_${NOW}.crt
FILEPATH_CRT=${PATH_CRT}/${FILENAME_CRT}

PATH_CRT_ROOTBUNDLE=${DIRECTORY_CERTIFICATES}
FILENAME_CRT_ROOTBUNDLE=${SITENAME}_${NOW}.rootbundle.crt
FILEPATH_CRT_ROOTBUNDLE=${PATH_CRT_ROOTBUNDLE}/${FILENAME_CRT_ROOTBUNDLE}


#make new private key and CSR for site
openssl req -out ${FILEPATH_CSR} -new -sha256 -newkey rsa:2048 -nodes -keyout ${FILEPATH_PRIVATE_KEY} -subj "${CSR_SUBJECT}"
#check the CSR request
#openssl req -text -noout -verify -in ${FILEPATH_CSR}


#get request signed SSL
python ${DIRECTORY_SCRIPT}/acme_tiny.py --account-key ${FILEPATH_ACCOUNT_PRIVATE_KEY} --csr ${FILEPATH_CSR} --acme-dir ${DIRECTORY_ACME_CHALLENGE} > ${FILEPATH_CRT_COMBINED}
#check combined signed SSL
#openssl x509 -in ${FILEPATH_CRT_COMBINED} -text -noout


#split combined file
rm ${DIRECTORY_CERTIFICATES}/certificate.*
python3 ${DIRECTORY_SCRIPT}/splitter.py --input ${FILEPATH_CRT_COMBINED} --output_prefix ${DIRECTORY_CERTIFICATES}/certificate.
#rename certificate
find ${DIRECTORY_CERTIFICATES}/certificate.* -type f -exec grep -q "${SITENAME}" {} \; -exec mv {} ${FILEPATH_CRT}  \;
#rename rootbundle
find ${DIRECTORY_CERTIFICATES}/certificate.* -type f -exec grep -q "${ROOT_CRT_KEYWORD}" {} \; -exec mv {} ${FILEPATH_CRT_ROOTBUNDLE}  \;
find ${DIRECTORY_CERTIFICATES}/certificate.* -type f -exec grep -q "${ROOT_CRT_KEYWORD2}" {} \; -exec mv {} ${FILEPATH_CRT_ROOTBUNDLE}  \;
#check signed SSL
#openssl x509 -in ${FILEPATH_CRT} -text -noout
#check root SSL
#openssl x509 -in ${FILEPATH_CRT_ROOTBUNDLE} -text -noout


#fix permissions for everything we made
chmod 600 ${FILEPATH_PRIVATE_KEY}
chmod 600 ${FILEPATH_CSR}
chmod 600 ${FILEPATH_CRT_COMBINED}
chmod 600 ${FILEPATH_CRT}
chmod 600 ${FILEPATH_CRT_ROOTBUNDLE}

#remove previous symboic links
rm -f ${SYMBOLICLINK_KEY}
rm -f ${SYMBOLICLINK_CRT_COMBINED}
rm -f ${SYMBOLICLINK_CRT}
rm -f ${SYMBOLICLINK_CRT_ROOTBUNDLE}

#setup new symbolic links
ln -s ${FILEPATH_PRIVATE_KEY} ${SYMBOLICLINK_KEY}
ln -s ${FILEPATH_CRT_ROOTBUNDLE} ${SYMBOLICLINK_CRT_ROOTBUNDLE}
ln -s ${FILEPATH_CRT} ${SYMBOLICLINK_CRT}
ln -s ${FILEPATH_CRT_COMBINED} ${SYMBOLICLINK_CRT_COMBINED}