import argparse, sys, os, textwrap, subprocess

def split_crt(filepath_input, filepath_prefix_output):
    #attempt to open file
    f_output = None
    if os.path.exists(filepath_input):
        with open(filepath_input) as f_input:
            line_count = 0
            output_counter = 0
            filepath_output = "%s%d" % (filepath_prefix_output, output_counter)
            for line in f_input:
                if f_output == None:
                    f_output = open(filepath_output, mode='w')
                line_count += 1
                #print("Line{}: {}".format(line_count, line.strip()))
                if line.strip() != "":
                    f_output.write(line)
                if line.strip() == "-----END CERTIFICATE-----":
                    f_output.close()
                    f_output = None
                    p = subprocess.run('openssl x509 -noout -text -in %s >> %s' % (filepath_output, filepath_output), shell=True, check=True, capture_output=True, encoding='utf-8')
                    output_counter += 1
                    filepath_output = "%s.%d" % (filepath_prefix_output, output_counter)
    if f_output != None:
        f_output.close()
    return

def main(argv=None):
    parser = argparse.ArgumentParser(
        formatter_class=argparse.RawDescriptionHelpFormatter,
        description=textwrap.dedent("""\
            This script splits a combined certificate into individual certificates

            Example Usage:
            splitter.py --input ./combined.crt --output_prefix ./certificate.
            """)
    )
    parser.add_argument("--input", required=True, help="path to a combined certificate")
    parser.add_argument("--output_prefix", required=True, help="path and prefix to split certificates")

    args = parser.parse_args(argv)
    signed_crt = split_crt(args.input, args.output_prefix)
    return

if __name__ == "__main__": # pragma: no cover
    main(sys.argv[1:])